// // if the variable is defined
'use strict';

var _Object$keys = require('babel-runtime/core-js/object/keys')['default'];

var _getIterator = require('babel-runtime/core-js/get-iterator')['default'];

exports.__esModule = true;
exports.extend = extend;
exports.merge = merge;
exports.clone = clone;
exports.alias_camel_case = alias_camel_case;
exports.replace_all = replace_all;
var exists = function exists(what) {
	return typeof what !== 'undefined';
};

exports.exists = exists;
// extends the first object with
/* istanbul ignore next: some weird transpiled code, not testable */

function extend() {
	var _this = this,
	    _arguments = arguments;

	var _again = true;

	_function: while (_again) {
		_len = objects = _key = to = from = last = intermediary_result = _iterator = _isArray = _i = _iterator = _ref = key = undefined;
		_again = false;

		for (var _len = _arguments.length, objects = Array(_len), _key = 0; _key < _len; _key++) {
			objects[_key] = _arguments[_key];
		}

		var to = objects[0];
		var from = objects[1];

		if (objects.length > 2) {
			var last = objects.pop();
			var intermediary_result = extend.apply(_this, objects);
			_this = undefined;
			_arguments = [intermediary_result, last];
			_again = true;
			continue _function;
		}

		for (var _iterator = _Object$keys(from), _isArray = Array.isArray(_iterator), _i = 0, _iterator = _isArray ? _iterator : _getIterator(_iterator);;) {
			var _ref;

			if (_isArray) {
				if (_i >= _iterator.length) break;
				_ref = _iterator[_i++];
			} else {
				_i = _iterator.next();
				if (_i.done) break;
				_ref = _i.value;
			}

			var key = _ref;

			if (typeof from[key] === 'object' && exists(to[key])) {
				to[key] = extend(to[key], from[key]);
			} else {
				to[key] = from[key];
			}
		}

		return to;
	}
}

function merge() {
	var parameters = Array.prototype.slice.call(arguments, 0);
	parameters.unshift({});
	return extend.apply(this, parameters);
}

function clone(object) {
	return merge({}, object);
}

// creates camelCased aliases for all the keys of an object

function alias_camel_case(object) {
	for (var _iterator2 = _Object$keys(object), _isArray2 = Array.isArray(_iterator2), _i2 = 0, _iterator2 = _isArray2 ? _iterator2 : _getIterator(_iterator2);;) {
		var _ref2;

		if (_isArray2) {
			if (_i2 >= _iterator2.length) break;
			_ref2 = _iterator2[_i2++];
		} else {
			_i2 = _iterator2.next();
			if (_i2.done) break;
			_ref2 = _i2.value;
		}

		var key = _ref2;

		if (key.indexOf('_') >= 0) {
			var camel_cased_key = key.replace(/_(.)/g, function (match, group_1) {
				return group_1.toUpperCase();
			});

			if (!exists(object[camel_cased_key])) {
				object[camel_cased_key] = object[key];
			}
		}
	}

	return object;
}

function escape_regexp(string) {
	var specials = new RegExp('[.*+?|()\\[\\]{}\\\\]', 'g');
	return string.replace(specials, '\\$&');
}

function replace_all(where, what, with_what) {
	var regexp = new RegExp(escape_regexp(what), 'g');
	return where.replace(regexp, with_what);
}
//# sourceMappingURL=helpers.js.map